
exception Unimplemented

exception NoNamedType of string
exception NoConstructor of string

type atype = 
  | Int (* int *)
  | Arrow of atype * atype (* arg-type, result type *)
  | Tuple of atype list (* n-tuple; ith element is ith type *)
  | Sum   of (string * atype) list (* sum with n constructors *)
  | Named of string (* named type *)
type typecontext = (string * atype) list

let rec lookup s lst exn =
  match lst with
    [] -> raise exn
  | (x,y)::tl -> if s=x then y else lookup s tl exn

(* your implementation may assume there are no recursive types; (silently
   going into an infinite loop in some cases otherwise) *)
let is_subtype (ctxt : typecontext) (t1 : atype) (t2 : atype) : bool =
  raise Unimplemented


(* testing -- you will probably want to add more :) *)
let c1 = [("t1",Int);("t2",Int)]
let b1 = is_subtype c1 (Named("t1")) (Named("t2"))
let b2 = is_subtype c1 (Named("t1")) (Tuple[Named("t2");Int])
let b3 = is_subtype c1 (Named("t1")) Int

let pb b = print_string(if b then "true" else "false"); print_newline()

let _ = pb b1
let _ = pb b2
let _ = pb b3
